<%@ page contentType="text/javascript" %>
<%@ taglib prefix="formfactory" uri="http://www.jahia.org/formfactory/functions" %>

<%-- eslint-begin --%>
(function() {
    'use strict';

    // validate es connection
    var validESConn = function($log, ffTemplateResolver) {
        var directive = {
            restrict: 'A',
            controller: ValidESConnController,
            controllerAs: 'vescc',
            bindToController: true,
            link: linkFunc
        };

        return directive;

        function linkFunc(scope, el, attr, ctrl) {
            // void
        }
    };
    angular
        .module('formFactory')
        .directive('ffValidEsconn', ['$log', 'ffTemplateResolver', validESConn]);

    var ValidESConnController = [
        'contextualData',
        'ffDataFactory',
        'i18nService',
        '$scope',
        function(contextualData, ffDataFactory, i18n, scope) {
            var vescc = this;
            vescc.selectESConnectionMessage = i18n.message('fcnt_saveToESAction.designView.label.selectESConnectionMessage');

            vescc.connections = [];

            vescc.$onInit = function() {
                loadConnections();
            };

            function loadConnections() {
                var request = {
                    url: contextualData.context + '/modules/dbconn/allconnections',
                    method: 'GET',
                    dataType: 'application/json'
                };
                ffDataFactory.customRequest(request).then(function(response) {
                    vescc.connections = angular.copy(response.connections);
                }, function(error) {
                    console.log(error);
                });
            }
        }
    ];

    // Define the action directive
    var saveToESAction = function($log, ffTemplateResolver) {
        var directive = {
            restrict: 'E',
            templateUrl: function(el, attrs) {
                return ffTemplateResolver.resolveTemplatePath('${formfactory:addFormFactoryModulePath('/form-factory-actions/save-to-elasticsearch/', renderContext)}', attrs.viewType);
            },
            link: linkFunc
        };
        return directive;

        function linkFunc(scope, el, attr) {
            // void
        }
    };

    angular
        .module('formFactory')
        .directive('ffSaveToEs', ['$log', 'ffTemplateResolver', saveToESAction]);
})();

<%-- eslint-end --%>
