<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form" %>
<%@ taglib prefix="query" uri="http://www.jahia.org/tags/queryLib" %>

<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="flowRequestContext" type="org.springframework.webflow.execution.RequestContext"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>

<template:addResources type="javascript" resources="app/polyfills.js"/>
<template:addResources type="javascript" resources="app/vendors.js"/>
<template:addResources type="javascript" resources="app/ffEsStorage.js"/>


<c:if test="${not empty param.realFormId}">
    <c:set var="realFormId" value="${param.realFormId}" scope="session"/>
</c:if>
<c:if test="${not empty param.buildingLang}">
    <c:set var="buildingLang" value="${param.buildingLang}" scope="session"/>
</c:if>
<c:if test="${not empty param.formUuid}">
    <c:set var="submissionsId" value="${param.formUuid}" scope="session"/>
</c:if>

<div id="esffapp">Loading...</div>

<script>
    (function () {
        console.log("Working...");
        //Compile renderer templates
        var compileTemplates = function (renderers) {
            var templateOptions = {
                interpolate: /\<\@\=(.+?)\@\>/gim,
                evaluate: /\<\@(.+?)\@\>/gim,
                escape: /\<\@\-(.+?)\@\>/gim,
                imports: {
                    _: _
                }
            };

            return _.reduce(renderers, function (acc, renderer, key) {
                acc[key] = _.template(renderer, templateOptions);
                return acc;
            }, {});
        };

        var renderers = JSON.parse(JSON.stringify(_resultsRenderer));

        if (renderers.fileUpload) {
            renderers.fileUpload = renderers.fileUpload
                .replace(/data\.url\.replace\('\/repository\/','\/files\/'\)/g, "data.url.replace('/modules/', '${url.context}/modules/')")
                .replace("<@=data.url@>", '${url.context}<@=data.url@>');
        }

        var context = {
            ctx: "${url.context}",
            formId: "${realFormId}",
            submissionsId: "${submissionsId}",
            language: "${currentResource.locale}",
            uiLanguage: "${renderContext.UILocale.language}",
            buildingLang: "${buildingLang}",
            rendererTemplates: compileTemplates(renderers),
            siteName: "${renderContext.site.name}",
            migrateActionUrl: "<c:url value='/cms/edit/default/${renderContext.UILocale.language}/sites/${renderContext.site.name}'/>.jcrtoesmigration.do"
        };

        window.ffesApp("esffapp", context);
    })();
</script>